<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

/** 
 * Table of Contents
 * 
 * 1. Shortcode
 * 2. Elementor Widget Creator
 */

//1. Shortcode
function crsffa_builder($params, $content) {
    extract( shortcode_atts( 
        array(
            'page_builder'                  => '',
            'action_url'                    => '',
            'affiliate_id'                  => '',
            'text_pick_up'                  => '',
            'placeholder_pick_up'           => '',
            'text_date'                     => '',
            'placeholder_date'              => '',
            'text_pick_up_time'             => '',
            'placeholder_pick_up_time'      => '',
            'text_dropp_off_time'           => '',
            'placeholder_dropp_off_time'    => '',
            'submit_button_label'           => '',
            'select_search'                 => '',
            'drivers_age'                   => '',
            'text_drivers_age'              => '',
        ), $params ) ); 

        $pick_up_location = uniqid('pick-up-location-input');
        $pick_up_date = uniqid('pick-up-date-');
        $pick_up_time = uniqid('pick-up-time-input');
        $drop_off_location_input = uniqid('drop-off-location-input');
        $drop_off_time_input = uniqid('drop-off-time-input');
        $drop_off_location_id = 'drop_off_location_id' . uniqid();
        $drive_age_between = uniqid('drive_age_between');
        $drive_age_id = uniqid('driver-age');
        // CSS
        wp_enqueue_style( 'crsffa-custom', plugins_url( 'assets/css/custom.css', __FILE__ ), array(), '1.0.0', 'all' );
        wp_enqueue_style( 'flatpickr', plugins_url( 'assets/css/flatpickr.min.css', __FILE__ ), array(), '1.0.0', 'all' );
        // js
        wp_enqueue_script( 'flatpickr', plugins_url( 'assets/js/flatpickr.js', __FILE__ ), array(), '4.6.13', 'all' );
        wp_enqueue_script( 'crsffa-custom', plugins_url( 'assets/js/custom.js', __FILE__ ), array(), '1.0.0', 'all' );
        ob_start(); 
        ?>
        <?php
        $action = 'https://';
        if ($select_search == 'booking_search') {
            $action .= 'cars.booking.com/search-results?aid=' . esc_attr($affiliate_id);
        } else {
            $action .= 'cars.kiwi.com/SearchResults.do?affiliateCode=' . esc_attr($affiliate_id);
        }
        $name = '';
        if ($select_search == 'booking_search') {
            $name .= 'locationName';
        } else {
            $name .= 'locationName';
        }
        $form_v = 'booking_search';
        if(isset($select_search) && !empty($select_search)){
            $form_v = $select_search;
        }
        ?> 
            <form action="<?php echo esc_url($action); ?>" method="get"  class="mt-rental-affiliate-search-form mt-rental-affiliate-search-element <?php echo esc_attr($form_v); ?>" >
                <div class="mt-rental-affiliate-element">
                <!-- Search Results -->
                    <div class="mt-rental-affiliat">
                        <div class="mt-rental-affiliat-display">
                            <div class="mt-rental-affiliate-pick-up-location-search-wrapper grid-item">
                                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M15 10.5a3 3 0 11-6 0 3 3 0 016 0z" />
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M19.5 10.5c0 7.142-7.5 11.25-7.5 11.25S4.5 17.642 4.5 10.5a7.5 7.5 0 1115 0z" />
                                </svg>
                                <div class="mt-rental-affiliate-pick-up-location-wrapper">
                                    <label class="mt-rental-affiliate-pick-up-location-label" for="<?php echo esc_attr($pick_up_location); ?>">
                                        <?php echo esc_html__( 'Pick-up location', 'crsffa' ); ?>
                                    </label>
                                    <input class="mt-rental-affiliate-pick-up-location-input" 
                                    autocomplete="false" 
                                    name="<?php echo esc_html($name); ?>" 
                                    coordinates="coordinates" 
                                    id="<?php echo esc_attr($pick_up_location); ?>" 
                                    type="text" 
                                    placeholder="<?php echo esc_attr($placeholder_pick_up); ?>"/>
                                </div>
                                <div id="pick-up-location-results-wrapper" class="mt-rental-affiliate-pick-up-location-results">
                                    <ul id="pick-up-location-results-list">
                                    </ul>
                                </div>
                            </div>
                            <!-- Location  Drop  car off-->
                            <div id="<?php echo esc_attr($drop_off_location_id); ?>-wrapper" class="mt-rental-affiliate-pick-up-location-search-wrapper different-location-input grid-item">
                                <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor">
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M15 10.5a3 3 0 11-6 0 3 3 0 016 0z" />
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M19.5 10.5c0 7.142-7.5 11.25-7.5 11.25S4.5 17.642 4.5 10.5a7.5 7.5 0 1115 0z" />
                                </svg>
                                <div class="mt-rental-affiliate-pick-up-location-wrapper">
                                    <label class="mt-rental-affiliate-second-location-label" for="<?php echo esc_attr($drop_off_location_input); ?>">
                                        <?php echo esc_html__( 'Drop-off location', 'crsffa' ); ?>
                                    </label>
                                    <input class="mt-rental-affiliate-pick-up-location-input" 
                                    autocomplete="false" 
                                    name="dropLocationName" 
                                    dropCoordinates="dropCoordinates" 
                                    id="<?php echo esc_attr($drop_off_location_input); ?>" 
                                    type="text" 
                                    placeholder="<?php echo esc_attr($placeholder_pick_up);?>"/>
                                </div>
                                <div id="second-location-results-wrapper" class="mt-rental-affiliate-second-location-results">
                                    <ul id="second-location-results-list">
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- PICK UP DATE -->
                    <div class="mt-rental-affiliate-search">
                        <div id="mt-rental-affiliate-pick-up-date-wrapper" class="mt-rental-affiliate-date-wrapper grid-item">
                            <svg
                                xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"bstroke-width="1.5" stroke="currentColor" data-toggle >
                                <path stroke-linecap="round" stroke-linejoin="round" d="M6.75 3v2.25M17.25 3v2.25M3 18.75V7.5a2.25 2.25 0 012.25-2.25h13.5A2.25 2.25 0 0121 7.5v11.25m-18 0A2.25 2.25 0 005.25 21h13.5A2.25 2.25 0 0021 18.75m-18 0v-7.5A2.25 2.25 0 015.25 9h13.5A2.25 2.25 0 0121 11.25v7.5"/>
                            </svg>
                            <div class="mt-rental-affiliate-date-select-wrapper">
                                <label for="<?php echo esc_attr($pick_up_date); ?>" class="mt-rental-affiliate-date-label">
                                    <?php echo esc_html($text_date);?>  
                                </label>
                                <input
                                    id="<?php echo esc_attr($pick_up_date); ?>"
                                    class="mt-rental-affiliate-date-input"
                                    placeholder="<?php echo esc_attr($placeholder_date); ?>"
                                    data-input
                                    puDay="puDay"
                                    puMonth="puMonth"
                                    puYear="puYear"
                                    doDay="doDay"
                                    doMonth="doMonth"
                                    doYear="doYear"
                                />
                            </div>
                        </div>
                        <!-- PICK UP TIME -->
                        <div id="mt-rental-affiliate-pick-up-time-wrapper" class="mt-rental-affiliate-time-wrapper grid-item">
                            <svg
                                xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" data-toggle>
                                <path stroke-linecap="round" stroke-linejoin="round" d="M12 6v6h4.5m4.5 0a9 9 0 11-18 0 9 9 0 0118 0z"/>
                            </svg>
                            <div class="mt-rental-affiliate-time-select-wrapper">
                                <label for="<?php echo esc_attr($pick_up_time); ?>" class="mt-rental-affiliate-time-label">
                                    <?php echo esc_html($text_pick_up_time);?>
                                </label>
                                <input
                                    id="<?php echo esc_attr($pick_up_time); ?>"
                                    class="mt-rental-affiliate-time-input"
                                    placeholder="<?php echo esc_attr($placeholder_pick_up_time); ?>"
                                    data-input
                                    puHour="puHour"
                                    puMinute="puMinute"
                                />
                            </div>
                        </div>
                        <!-- DROP OFF TIME -->
                        <div id="mt-rental-affiliate-drop-off-time-wrapper" class="mt-rental-affiliate-time-wrapper grid-item">
                            <svg
                                xmlns="http://www.w3.org/2000/svg"
                                fill="none"
                                viewBox="0 0 24 24"
                                stroke-width="1.5"
                                stroke="currentColor"
                                data-toggle
                            >
                                <path
                                    stroke-linecap="round"
                                    stroke-linejoin="round"
                                    d="M12 6v6h4.5m4.5 0a9 9 0 11-18 0 9 9 0 0118 0z"
                                />
                            </svg>
                            <div class="mt-rental-affiliate-time-select-wrapper">
                                <label for="<?php echo esc_attr($drop_off_time_input); ?>" class="mt-rental-affiliate-time-label">
                                    <?php echo esc_html($text_dropp_off_time);?>
                                </label>
                                <input
                                    id="<?php echo esc_attr($drop_off_time_input); ?>"
                                    class="mt-rental-affiliate-time-input"
                                    placeholder="<?php echo esc_attr($placeholder_dropp_off_time);?>"
                                    data-input
                                    doHour="doHour"
                                    doMinute="doMinute" 
                                />
                            </div>
                        </div>
                        <?php if ($select_search == 'kiwi_search') { ?>
                            <input type="hidden" value="C" name="ftsType" /> 
                            <input type="hidden" value="-1" name="ftsLocationSearch" /> 
                            <input type="hidden" value="allareasgeosearch" name="searchType" /> 
                            <input type="hidden" value="L" name="ftsSearch" /> 
                        <?php } ?>
                        <!-- SEARCH SUBMIT -->
                        <button formtarget="_blank" type="submit" class="mt-rental-affiliate-search-element-submit">
                            <?php echo esc_attr($submit_button_label); ?>
                        </button>
                    </div>
                </div>
                <div class="mt-rental-affiliate-check">
                    <label class="mt-rental-affiliate-checkbox">
                        <input class="mt-rental-affiliate-different-location-input" type="checkbox" id="<?php echo esc_attr($drop_off_location_id); ?>"><?php echo esc_html__('Drop car off at different location','crsffa'); ?>
                    </label>
                </div>
                <div class="mt-rental-affiliate-check mt-rental-affiliate-age">
                    <label class="mt-rental-affiliate-checkbox" for="<?php echo esc_attr($drive_age_between); ?>">
                        <input id="<?php echo esc_attr($drive_age_between); ?>" class="mt-rental-affiliate-driver-age-input" type="checkbox" checked="true" value="<?php echo esc_html($name);?>">
                        <?php echo esc_html__('Driver aged between 30 - 65?','crsffa'); ?> 
                    </label>
                    <div class="driver-age" style="display: none;">
                        <label for="<?php echo esc_attr($drive_age_id); ?>"><?php echo esc_html__("Driver's Age", 'crsffa'); ?></label>
                        <input id="<?php echo esc_attr($drive_age_id); ?>" name="driversAge" type="number" value="<?php echo esc_attr($drivers_age);?>" />
                    </div>
                </div>
            </form>  
        <?php
        return ob_get_clean();
    }
add_shortcode('crsffa-builder-shortcode', 'crsffa_builder');

// 2. Elementor Widget Creator
if (in_array('elementor/elementor.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    class CRSFFA_Elementor_Widgets {

        protected static $instance = null;

        public static function get_instance() {
            if ( ! isset( static::$instance ) ) {
                static::$instance = new static;
            }

            return static::$instance;
        }

        protected function __construct() {
            require_once('elementor.php');

            add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
        }

        public function register_widgets() {
            \Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\CRSFFA_Widget() );
        }

    }
    // Elementor Init
    add_action( 'init', 'crsffa_elementor_init' );
    function crsffa_elementor_init() {
        CRSFFA_Elementor_Widgets::get_instance();
    }

    // Elementor Widgets Category
    function crsffa_widget_categories( $elements_manager ) {
        $elements_manager->add_category(
            'modeltheme-widgets',
            [
                'title' => esc_html__( 'Modeltheme Widgets', 'crsffa' ),
                'icon' => 'fas fa-plug',
            ]
        );
    }
    add_action( 'elementor/elements/categories_registered', 'crsffa_widget_categories' );
}

